package agent.mapper;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import agentspace.AgentIdentifier;
import agentspace.Context;
import agentspace.Message;

public class MapperWindow extends JFrame implements ActionListener {
	final int NUMBER = 2;

	Context context;
	JPanel controlPanel;
	JTextField execField;
	JButton addButton;
	JButton mapButton;
	JButton runButton;
	JPanel assignPanel;
	
	JPanel[] targetPanels;
	JTextField[] pathFields;
	JTextField[] addrFields;
	JButton[] buttons;

	AgentIdentifier[] ids;
	
	String[] path = {"samples/text/macbeth.txt",
					"samples/text/romeo.txt"}; 
	String urlString[] = {"matp://localhost:7000",   "matp://localhost:7000"};
		
	String EXECAGENT = "samples/Wordcount.jar";
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MapperWindow f = new MapperWindow(null);
	}
	
	public MapperWindow(Context context) {
		super("Mapper Agent");
		this.context = context;
		getContentPane().setLayout(new BorderLayout());
		getContentPane().setBackground(Color.white);
		setBackground(Color.white);
		
		controlPanel = new JPanel();
		execField = new JTextField(EXECAGENT, 20);
		execField.setBorder(new TitledBorder("Executor:"));
		controlPanel.add(execField);
		addButton = new JButton("Add"); 
		addButton.setActionCommand("Add");
		addButton.addActionListener(this);
		mapButton = new JButton("Map"); 
		mapButton.setActionCommand("Map");
		mapButton.addActionListener(this);
		controlPanel.add(mapButton);
		runButton = new JButton("Run"); 
		runButton.setActionCommand("Run");
		runButton.addActionListener(this);
		controlPanel.add(runButton);
		getContentPane().add(controlPanel, BorderLayout.NORTH);

		assignPanel = new JPanel();
		targetPanels = new JPanel[NUMBER]; 
		pathFields = new JTextField[NUMBER];
		addrFields = new JTextField[NUMBER];
		for (int i = 0 ; i < NUMBER ; i++ ) {
			targetPanels[i] = new JPanel(); 	
			addrFields[i] = new JTextField(urlString[i], 20);
			addrFields[i].setBorder(new TitledBorder("Target URL:"));
			pathFields[i] = new JTextField(path[i], 20);
			pathFields[i].setBorder(new TitledBorder("Target file(s):"));
	        targetPanels[i].add(addrFields[i]);
	        targetPanels[i].add(pathFields[i]);
	        assignPanel.add(targetPanels[i]);
		}
		getContentPane().add(assignPanel, BorderLayout.CENTER);		
		setSize(510, 200);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent evt) {
		if (ids == null) {
			ids = new AgentIdentifier[NUMBER];
		}
		String action = evt.getActionCommand();
		if (action.equals("Map")) {
			for (int i = 0 ; i < NUMBER ; i++ ){
				try {
//					System.out.println("MapperWindow: load("+execField.getText()+")");
					ids[i] = context.load(execField.getText());
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
				try {
					Message msg = new Message("setTarget");
					msg.setArg(addrFields[i].getText());
//					System.out.println("invoke("+msg+")");
					context.invoke(ids[i], msg);
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
				try {
					Message msg = new Message("setPath");
					msg.setArg(pathFields[i].getText());
//					System.out.println("invoke("+msg+")");
					context.invoke(ids[i], msg);
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		}
		else if (action.equals("Run")) {
			for (int i = 0 ; i < NUMBER ; i++ ){
				try {
//					System.out.println("MapperWindow: load("+execField.getText()+")");
//					ids[i] = context.load(execField.getText());
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
				try {
					Message msg = new Message("go");
					msg.setArg(new URL(addrFields[i].getText()));
					msg.setArg(pathFields[i].getText());
					context.invoke(ids[i], msg);
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		} 
	}
}
