package agent.reducer;

import java.awt.Rectangle;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Map;
import java.util.Vector;

import agentspace.Agent;
import agentspace.Context;
import agentspace.InvalidURLException;
import agentspace.Mobile;
import agentspace.event.AgentEvent;

public class ReducerAgent implements Agent, Mobile {
	Map map = null;
	Context context;
	ReducerWindow window = null;
	
	String urlString = null;
	URL homeURL = null;
	String pattern = null;
	String path = "/Users/ichiro/work/as6/test.txt";
	Rectangle rect = null;
	URL targetURL = null;
	String result = "";
	String NAME = "Reducer";	
	boolean searching = false;
	
	public void create(AgentEvent evt, Context context) {
		this.context = context;
		context.setName(NAME);
		System.out.println("WordCount: method create() called");
		if (homeURL == null) {
			homeURL = context.getHostURL();
		}
		window = new ReducerWindow(this, path);
		window.setVisible(true);
		this.context = context;
	}

	/* 
	 * @see agentspace.SerialiableAgent#destroy(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void destroy(AgentEvent evt, Context context) {
		System.out.println("WordCount: method destroy() called");
		if (window != null) {
			window.setVisible(false);
		}
	}
	/* 
	 * @see agentspace.SerialiableAgent#suspend(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void suspend(AgentEvent evt, Context context) {
		System.out.println("WordCount: method suspend() called");
		if (window != null) {
			window.setVisible(false);
		}
	}

	/* 
	 * @see agentspace.SerialiableAgent#resume(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void resume(AgentEvent evt, Context context) {
		System.out.println("WordCount: method resume() called");
		window.setVisible(true);
	}
	/* 
	 * @see agentspace.MobileAgent#arrive(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void arrive(AgentEvent evt, Context context) {
		this.context = context;
		System.out.println("WordCount: method arrive() called");
		window.setVisible(true);
	}
		
	/* 
	 * @see agentspace.MobileAgent#leave(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void leave(AgentEvent evt, Context context) {
		System.out.println("WordCount: method leave() called");
		if (window != null) {
			rect = window.getBounds();
			window.setVisible(false);
		}
	}
	
	public void clear() {
		map.clear();
		window.setMap(map);
		window.setVisible(true);
	}
	
	public void addMap(Map copy) {
//		System.out.println("ReducerAgent: copy "+copy);
		if (map != null) {
			MapUtil.merge(copy, map);
//			System.out.println("ReducerAgent: map "+map);
		}
		else {
			map = copy; 
		}
//		result = compare(path, pattern);
		window.setMap(map);
		window.setVisible(true);
	}

	public Map getMap() {
		return map;
	}
}

