package agent.reducer;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class ReducerWindow extends JFrame implements ActionListener {
	URL homeURL = null;
	URL targetURL = null;
	Map map = null;
	JPanel networkPanel;
	JComponent comp = null;
	JComponent scrollpane = null;
	JButton clearButton;
	String path = "agent/grep/Grep.java";
	String urlString = "matp://localhost:7000";
	transient TableMapPanel table = null;
	
	public ReducerWindow(ReducerAgent agent, String path) {
		super("Reducer Agent");
		this.path = path;

		networkPanel = new JPanel();
		clearButton = new JButton("Clear");
		clearButton.setActionCommand("Clear");
		clearButton.addActionListener(this);
		networkPanel.add(clearButton);

		if (map == null) {
			map = new HashMap();
		}

		table = new TableMapPanel();
		scrollpane = new JScrollPane(table);
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(networkPanel, BorderLayout.NORTH);
		getContentPane().add(scrollpane, BorderLayout.CENTER);
		setSize(390, 280);
	}

	public void setMap(Map mapdata) {
		getContentPane().remove(scrollpane);
		table = new TableMapPanel();
		scrollpane = new JScrollPane(table);
		getContentPane().add(scrollpane, BorderLayout.CENTER);
		Iterator it = mapdata.keySet().iterator();
		while (it.hasNext()) {
			String key = (String)it.next();
			Object value = mapdata.get(key);
//			System.out.println("ReducerWindow: key = "+key+", value = "+value);
			table.addEntry(key, value);
		}
		setVisible(true);
	}

	public void actionPerformed(ActionEvent evt) {
		String action = evt.getActionCommand();
		if (action.equals("Clear")) {
			map.clear();
			setMap(map);
			setVisible(true);
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ReducerWindow rw = new ReducerWindow(null, "Users/ichiro/work/as6/test.txt");
		rw.setVisible(true);
	}

}
