
package agent.window;

import javax.swing.JFrame;
import javax.swing.JTextArea;

import agentspace.Agent;
import agentspace.Context;
import agentspace.Mobile;
import agentspace.event.AgentEvent;

public class Window implements Agent, Mobile {
	AgentFrame frame = null;

	class AgentFrame extends JFrame {
		JTextArea area;
		public AgentFrame() {
			super("Window Agent");
			area = new JTextArea(80, 20);
			area.setText("Input text here.\n");
			area.setVisible(true);
			getContentPane().add(area);
			setSize(300, 200);
		}
	}
	
	public Window() {
		System.out.println("Window: an instance created.");
	}
	/* 
	 * @see agentspace.SerialiableAgent#create(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void create(AgentEvent evt, Context context) {
		System.out.println("Window: method create() called");
		frame = new AgentFrame();
		frame.setVisible(true);
	}
	/* 
	 * @see agentspace.SerialiableAgent#destroy(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void destroy(AgentEvent evt, Context context) {
		System.out.println("Window: method destroy() called");
		frame.setVisible(false);
	}
	/* 
	 * @see agentspace.SerialiableAgent#suspend(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void suspend(AgentEvent evt, Context context) {
		System.out.println("Window: method suspend() called");
		frame.setVisible(false);
	}

	/* 
	 * @see agentspace.SerialiableAgent#resume(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void resume(AgentEvent evt, Context context) {
		System.out.println("Window: method resume() called");
		frame.setVisible(true);
	}
	/* 
	 * @see agentspace.MobileAgent#arrive(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("Window: method arrive() called");
		frame.setVisible(true);
	}
	/* 
	 * @see agentspace.MobileAgent#leave(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void leave(AgentEvent evt, Context context) {
		System.out.println("Window: method leave() called");
		frame.setVisible(false);
	}
}
