/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/6
 */

package agentspace.network;

import java.util.Hashtable;

public class AgentSocketClient {
	static Hashtable handlers = new Hashtable();
	
	public static URLSessionHandler createURLSessionHandler(String protocol) {
		URLSessionHandler handler = (URLSessionHandler)handlers.get(protocol);
		if (handler == null) {
			String className = "agentspace.network.protocol." + protocol.toLowerCase() + ".URLSessionHandler";
			try {
				handler = (URLSessionHandler)Class.forName(className).newInstance();
			}
			catch (ClassNotFoundException e) {
				handler = null;
				e.printStackTrace();
			}
			catch (Exception e) {
				handler = null;
				e.printStackTrace();
			}
			if (handler != null) {
				handlers.put(protocol, handler);
			}
		}
		return handler;
	}
}
