/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/7
 */

package agentspace.serial;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectStreamClass;
import java.io.StreamCorruptedException;

public class MarshalInputStream extends ObjectInputStream {
    protected ClassLoader loader = null;

    /**
     * Create a new MarshalInputStream object.
     */
    public MarshalInputStream(InputStream in, ClassLoader loader)
    throws IOException, StreamCorruptedException {	      
      super(in);
      this.loader = loader;
      enableResolveObject(true);
    }
    
    /**
     * Create a new MarshalInputStream object.
     */
    public MarshalInputStream(InputStream in)
    throws IOException, StreamCorruptedException {	      
      super(in);
    }
    
    protected Class resolveClass(ObjectStreamClass classDesc)
    throws IOException, ClassNotFoundException {
      String className = classDesc.getName();
      return loader.loadClass(className);
    }
}
